/*
 * Created by SharpDevelop.
 * User: xxxx
 * Date: 2007/09/17
 * Time: 14:59
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.IO;
using System.Text;
using System.Collections;

namespace bioshock_ini_unpacker
{
	/// <summary>
	/// Description of IBFParser.
	/// </summary>
	public class IBFParser
	{
		public IBFParser()
		{
			//
		}
		
		private string TargetFileName;
		private string TargetFolderName;
		public IBFItem[] Items;
		
		public IBFItem[] parse(BinaryReader inFile)
		{
			int filename_len = 0;
			string filename = null;
			int content_len = 0;
			byte[] content;
			ArrayList list = new ArrayList();
			Encoding enc_uni = Encoding.GetEncoding("UTF-16");
			
			try
			{
				while(true)
				{
					filename_len = int.Parse(inFile.ReadByte().ToString());
					filename = enc_uni.GetString(inFile.ReadBytes((filename_len-1)*2));
					inFile.ReadBytes(2);
					content_len = (int)inFile.ReadUInt32();
					content = inFile.ReadBytes(content_len);
					list.Add(new IBFItem(filename, content_len, content));
				}
			}
			catch(EndOfStreamException e)
			{
				//
			}
			
			return (IBFItem[])list.ToArray(typeof(IBFItem));
		}
		
		public void unpack(string TargetFileName)
		{
			this.TargetFileName = TargetFileName;
			BinaryReader inFile = new BinaryReader(File.OpenRead(TargetFileName));
			this.Items = parse(inFile);
			inFile.Close();

			string dirname = Path.GetFileNameWithoutExtension(TargetFileName);
			Directory.CreateDirectory(dirname);
			foreach(IBFItem item in this.Items)
			{
				Console.WriteLine(item.FileName);
				FileStream cur_file = File.Create(dirname + "\\" + item.FileName);
				cur_file.Write(item.FileContent, 0, item.FileContent.Length);
				cur_file.Close();
			}
		}
		
		public void pack(string TargetFolderName)
		{
			this.Items = scanFolder(TargetFolderName);
			Encoding enc_uni = Encoding.GetEncoding("UTF-16");
			string[] dirnames = Path.GetFullPath(TargetFolderName).Split('\\');
			string outputFilename = dirnames[dirnames.Length-1] + ".IBF";
			
			BinaryWriter outFile = new BinaryWriter(File.Create(outputFilename));
			foreach(IBFItem item in this.Items)
			{
				outFile.Write(byte.Parse((item.FileName.Length+1).ToString()));
				outFile.Write(enc_uni.GetBytes(item.FileName));
				outFile.Write((byte)0);
				outFile.Write((byte)0);
				outFile.Write((uint)item.FileSize);
				outFile.Write(item.FileContent);
			}
			outFile.Close();
		}
		
		public IBFItem[] scanFolder(string TargetFolderName)
		{
			this.TargetFolderName = TargetFolderName;
			ArrayList list = new ArrayList();
			
			DirectoryInfo dir = new DirectoryInfo(TargetFolderName);
			foreach(FileInfo file in dir.GetFiles())
			{
				BinaryReader inFile = new BinaryReader(file.OpenRead());
				byte[] content = inFile.ReadBytes((int)file.Length);
				inFile.Close();
				list.Add(new IBFItem(file.Name, (int)file.Length, content));
			}
			return (IBFItem[])list.ToArray(typeof(IBFItem));
		}
	}
}
